"use strict";

exports.__esModule = true;
exports.default = void 0;
var _util = _interopRequireDefault(require("./util"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var Decode = function () {
  function Decode() {}
  var _proto = Decode.prototype;
  _proto.btou = function btou(u) {
    return u.replace(/[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g, function (cccc) {
      switch (cccc.length) {
        case 4:
          var cp = (0x07 & cccc.charCodeAt(0)) << 18 | (0x3f & cccc.charCodeAt(1)) << 12 | (0x3f & cccc.charCodeAt(2)) << 6 | 0x3f & cccc.charCodeAt(3),
            offset = cp - 0x10000;
          return _util.default.fromCC((offset >>> 10) + 0xD800) + _util.default.fromCC((offset & 0x3FF) + 0xDC00);
        case 3:
          return _util.default.fromCC((0x0f & cccc.charCodeAt(0)) << 12 | (0x3f & cccc.charCodeAt(1)) << 6 | 0x3f & cccc.charCodeAt(2));
        default:
          return _util.default.fromCC((0x1f & cccc.charCodeAt(0)) << 6 | 0x3f & cccc.charCodeAt(1));
      }
    });
  };
  _proto.atob = function atob(asc, ch, padchar) {
    var _Util$getChsTab = _util.default.getChsTab(ch),
      tab = _Util$getChsTab.tab;
    asc = asc.replace(/\s+/g, '');
    asc += (padchar || '==').slice(2 - (asc.length & 3));
    var u24,
      bin = '',
      r1,
      r2;
    for (var i = 0; i < asc.length;) {
      u24 = tab[asc.charAt(i++)] << 18 | tab[asc.charAt(i++)] << 12 | (r1 = tab[asc.charAt(i++)]) << 6 | (r2 = tab[asc.charAt(i++)]);
      bin += r1 === 64 ? _util.default.fromCC(u24 >> 16 & 255) : r2 === 64 ? _util.default.fromCC(u24 >> 16 & 255, u24 >> 8 & 255) : _util.default.fromCC(u24 >> 16 & 255, u24 >> 8 & 255, u24 & 255);
    }
    return bin;
  };
  _proto.get = function get(a, ch, padchar) {
    return this.btou(this.atob(a, ch, padchar)).replace(/\x00/ig, '');
  };
  return Decode;
}();
var _default = new Decode();
exports.default = _default;