"use strict";

exports.__esModule = true;
exports.default = void 0;
var _util = _interopRequireDefault(require("./util"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var Encode = function () {
  function Encode() {}
  var _proto = Encode.prototype;
  _proto.utob = function utob(u) {
    return u.replace(/[\uD800-\uDBFF][\uDC00-\uDFFFF]|[^\x00-\x7F]/g, function (c) {
      if (c.length < 2) {
        var cc = c.charCodeAt(0);
        return cc < 0x80 ? c : cc < 0x800 ? _util.default.fromCC(0xc0 | cc >>> 6) + _util.default.fromCC(0x80 | cc & 0x3f) : _util.default.fromCC(0xe0 | cc >>> 12 & 0x0f) + _util.default.fromCC(0x80 | cc >>> 6 & 0x3f) + _util.default.fromCC(0x80 | cc & 0x3f);
      } else {
        var _cc = 0x10000 + (c.charCodeAt(0) - 0xD800) * 0x400 + (c.charCodeAt(1) - 0xDC00);
        return _util.default.fromCC(0xf0 | _cc >>> 18 & 0x07) + _util.default.fromCC(0x80 | _cc >>> 12 & 0x3f) + _util.default.fromCC(0x80 | _cc >>> 6 & 0x3f) + _util.default.fromCC(0x80 | _cc & 0x3f);
      }
    });
  };
  _proto.btoa = function btoa(bin, ch, padchar) {
    var u32,
      c0,
      c1,
      c2,
      asc = '';
    var _Util$getChsTab = _util.default.getChsTab(ch),
      chs = _Util$getChsTab.chs;
    var pad = bin.length % 3;
    for (var i = 0; i < bin.length;) {
      if ((c0 = bin.charCodeAt(i++)) > 255 || (c1 = bin.charCodeAt(i++)) > 255 || (c2 = bin.charCodeAt(i++)) > 255) throw new TypeError('invalid character found');
      u32 = c0 << 16 | c1 << 8 | c2;
      asc += chs[u32 >> 18 & 63] + chs[u32 >> 12 & 63] + chs[u32 >> 6 & 63] + chs[u32 & 63];
    }
    return pad ? asc.slice(0, pad - 3) + (padchar || "===").substring(pad) : asc;
  };
  _proto.get = function get(bin, ch, padchar) {
    return this.btoa(this.utob(bin), ch, padchar);
  };
  return Encode;
}();
var _default = new Encode();
exports.default = _default;